VERSION 5.00
Object = "{67397AA1-7FB1-11D0-B148-00A0C922E820}#6.0#0"; "MSADODC.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Cheap Dynamic Queries Example"
   ClientHeight    =   2565
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4575
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2565
   ScaleWidth      =   4575
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame2 
      Caption         =   "Commands"
      Height          =   975
      Left            =   0
      TabIndex        =   5
      Top             =   120
      Width           =   4575
      Begin VB.CommandButton Command1 
         Caption         =   "How many records?"
         Height          =   375
         Left            =   240
         TabIndex        =   7
         Top             =   360
         Width           =   1935
      End
      Begin VB.CommandButton Command2 
         Caption         =   "IDs of records?"
         Height          =   375
         Left            =   2400
         TabIndex        =   6
         Top             =   360
         Width           =   1935
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Queries"
      Height          =   1455
      Left            =   0
      TabIndex        =   0
      Top             =   1080
      Width           =   4575
      Begin MSComctlLib.Slider Slider1 
         Height          =   375
         Left            =   120
         TabIndex        =   1
         Top             =   360
         Width           =   2055
         _ExtentX        =   3625
         _ExtentY        =   661
         _Version        =   393216
         Min             =   100000
         Max             =   350000
         SelStart        =   100000
         TickFrequency   =   50000
         Value           =   100000
      End
      Begin MSComctlLib.Slider Slider2 
         Height          =   390
         Left            =   120
         TabIndex        =   2
         Top             =   840
         Width           =   2055
         _ExtentX        =   3625
         _ExtentY        =   688
         _Version        =   393216
         Min             =   1965
         Max             =   2001
         SelStart        =   1965
         TickFrequency   =   5
         Value           =   1965
      End
      Begin VB.Label Label2 
         Caption         =   "Year Built > "
         Height          =   255
         Left            =   2280
         TabIndex        =   4
         Top             =   840
         Width           =   2175
      End
      Begin VB.Label Label1 
         Caption         =   "Asking Price <"
         Height          =   255
         Left            =   2280
         TabIndex        =   3
         Top             =   360
         Width           =   2175
      End
   End
   Begin MSAdodcLib.Adodc Adodc1 
      Height          =   375
      Left            =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   2535
      _ExtentX        =   4471
      _ExtentY        =   661
      ConnectMode     =   0
      CursorLocation  =   3
      IsolationLevel  =   -1
      ConnectionTimeout=   15
      CommandTimeout  =   30
      CursorType      =   3
      LockType        =   3
      CommandType     =   8
      CursorOptions   =   0
      CacheSize       =   50
      MaxRecords      =   0
      BOFAction       =   0
      EOFAction       =   0
      ConnectStringType=   1
      Appearance      =   1
      BackColor       =   -2147483643
      ForeColor       =   -2147483640
      Orientation     =   0
      Enabled         =   -1
      Connect         =   ""
      OLEDBString     =   ""
      OLEDBFile       =   ""
      DataSourceName  =   ""
      OtherAttributes =   ""
      UserName        =   ""
      Password        =   ""
      RecordSource    =   ""
      Caption         =   "Adodc1"
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      _Version        =   393216
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim strPrice As String
Dim strYear As String

' this button just spits out a count of how many records the latest dyno query returned
Private Sub Command1_Click()
    MsgBox Adodc1.Recordset.RecordCount, vbOKOnly, "# of Records Returned"
End Sub

' this button will step through the records one by one and save their ids in a string,
' which is then displayed in a message box.
Private Sub Command2_Click()

    Dim duh As String
    duh = ""

    With Adodc1.Recordset
        ' move to the first record, top o' the list
        .MoveFirst
        While Not .EOF
            ' this saves the value in the ID field of the current record.  Hint: you can
            ' do the same thing for any other column in the db / record / whatever
            ' (so .Recordset!YearBuilt would return that number for the current record)
            duh = duh & " " & !ID
            .MoveNext
        Wend
    End With
    
    MsgBox duh, vbOKOnly, "IDs of Records Returned"
End Sub

Private Sub Form_Load()
    ' init some values for the query strings (note: it _always_ needs a query for YearBuilt,
    ' I just set it to be one less than the lowest number in the db.  This is a cheap hack.
    ' It does get requeried on the fly, this just sort of seeds the preliminary results. The
    ' reason there needs to be a yearbuilt query is that everything else gets anded on the
    ' end, and without it the logic won't make sense to the sql query dude.)
    strPrice = ""
    strYear = " YearBuilt > 1964"
    
    With Adodc1
        ' initialize our connection to the database
        .ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & _
            App.Path & "\housedata.mdb;Persist Security Info=False"
        ' set up the first query
        .RecordSource = BuildQuery()
        ' refresh the data source to make sure the query goes through. I'm still unclear
        ' as to how a bunch of this works...
        .Refresh
    End With

    Label2.Caption = "Year Built > " & Slider2.Value
End Sub

' here's some hip query action happening and stuff.  (slider1 does price, slider2
' does construction date)
Private Sub Slider1_Change()
    strPrice = " and AskingPrice < " & Slider1.Value
    Label1.Caption = "Asking Price < $" & Slider1.Value & ".00"
    Adodc1.RecordSource = BuildQuery()
    Adodc1.Refresh
End Sub

Private Sub Slider2_Change()
    strYear = " YearBuilt > " & Slider2.Value
    Label2.Caption = "Year Built > " & Slider2.Value
    Adodc1.RecordSource = BuildQuery()
    Adodc1.Refresh
End Sub

' this function just builds an sql query based on a bunch of substrings that are managed
' by individual controls in this project and are stored globally.
Private Function BuildQuery() As String
    BuildQuery = "select * from Houses where " & strYear & strPrice
End Function


